/** Generates a QuartusII .mif file.
 @author Neil
 @version 1
 @since 2015 */

#include <stdlib.h> /* EXIT_ */
#include <stdio.h>  /* fprintf */
#include <math.h>   /* sin, M_PI, round */

/** entry point
 @param argc the number of arguments starting with the programme name
 @param argv the arguments
 @return     either EXIT_SUCCESS or EXIT_FAILURE */
int main(int argc, char **argv) {
	int i, x;

	printf("DEPTH = 256;\n");
	printf("WIDTH = 24;\n"); /* ? */
	printf("ADDRESS_RADIX = UNS;\n"); /* DEC no */
	printf("DATA_RADIX = UNS;\n"); /* DEC no */
	printf("CONTENT\nBEGIN\n");

	for(i = 0; i < 256; i++) {

		/* 60 * 50000000 / 24 / bpm, shifted 45 */
		x = round(((argc == 1) ? 125000000.0 : 125000.0) / (i + 45));

		printf("%3d : %d;\n", i, x);
	}

	printf("END;\n");

	return EXIT_SUCCESS;
}
